#include <bits/stdc++.h>
#define ll long

using namespace std;

int main()
{
    cin.tie(0);cout.tie(0);
    ios_base::sync_with_stdio(false);
    int n,q;
    cin >> n >> q;
    int d[n];
    int x;
    for(int i = 0; i < n;i++)
    {
        cin >> x >> d[i];
    }
    for(int i = 0; i < q;i++)
    {
        int h;
        int s = 0;
        cin >> h;
        for(int j = 0;j < n;j++)
        {
            s+=d[j];
            h-=s;
            if(h <= 0)
            {
                cout << j+1;break;
            }
        }
        if(h > 0) cout << -1;
    }
}